package fr.irisa.cairn.jnimap.isl;

import java.util.AbstractMap;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;

import fr.irisa.cairn.jnimap.runtime.JNIObject;


/*** PROTECTED REGION ID(ISLASTIfNode_userImport) ENABLED START ***/
	/*
		Put you custom import here ....
	*/
/*** PROTECTED REGION END ***/

/**
 *  Automatically generated by jnimap 
 * @generated
 */
public class ISLASTIfNode extends ISLASTNode  {
	
	/* @generated */
	protected ISLASTIfNode(long ptr) {
		/*** PROTECTED REGION ID(ISLASTIfNode_Constructor) DISABLED START ***/
		super(ptr);
		/*** PROTECTED REGION END ***/
	}
	
	/* @generated */
	protected static ISLASTIfNode build(long ptr) {
		return new ISLASTIfNode(ptr);
	}
	
	/*** PROTECTED REGION ID(ISLASTIfNode_userCode) ENABLED START ***/
	/*** PROTECTED REGION END ***/

	
	/*************************************** 
	 *	         Static Methods            * 
	 ***************************************/
	
	/*************************************** 
	 *	         Member Methods            * 
	 ***************************************/
	/**
	 * isl_ast_node_if_get_cond 
	 * 
	 * @generated
	**/
	public ISLASTExpression getCond() {
		/*** PROTECTED REGION ID(isl_ast_node_if_get_cond) DISABLED START ***/
		ISLASTExpression res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLASTExpression.build(ISLNative.isl_ast_node_if_get_cond(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_ast_node_if_get_then 
	 * 
	 * @generated
	**/
	public ISLASTNode getThen() {
		/*** PROTECTED REGION ID(isl_ast_node_if_get_then) DISABLED START ***/
		ISLASTNode res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLASTNode.build(ISLNative.isl_ast_node_if_get_then(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_ast_node_if_has_else 
	 * 
	 * @generated
	**/
	public int hasElse() {
		/*** PROTECTED REGION ID(isl_ast_node_if_has_else) DISABLED START ***/
		int res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_ast_node_if_has_else(getNativePtr(this));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_ast_node_if_get_else 
	 * 
	 * @generated
	**/
	public ISLASTNode getElse() {
		/*** PROTECTED REGION ID(isl_ast_node_if_get_else) DISABLED START ***/
		ISLASTNode res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLASTNode.build(ISLNative.isl_ast_node_if_get_else(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	
	public void accept(IISLASTNodeVisitor visitor) {
		visitor.visitISLASTIfNode(this);
	}
	
	public String toString() {
		/*** PROTECTED REGION ID(ISLASTIfNode_toString) DISABLED START ***/
			return ISLPrettyPrinter.asString(this);
		/*** PROTECTED REGION END ***/
	}
}
